From ffadd383957c8914d93f5a5c3ac5013354d615d5 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Thu, 28 Jan 2021 16:22:46 +0100
Subject: [PATCH] themes: remove useless .large class on #content (#50094)

---
 static/alpes-maritimes-2018/_custom.scss | 2 +-
 static/cnil/_custom.scss                 | 2 +-
 static/includes/wcs/_bulk.scss           | 2 +-
 static/lille/_custom.scss                | 2 +-
 static/metz-metropole-2019/_custom.scss  | 2 +-
 static/minint/sass/_form.scss            | 2 +-
 static/minint/sass/_team.scss            | 2 +-
 static/villejuif/_custom.scss            | 2 +-
 templates/theme.html                     | 2 +-
 9 files changed, 9 insertions(+), 9 deletions(-)

diff --git a/static/alpes-maritimes-2018/_custom.scss b/static/alpes-maritimes-2018/_custom.scss
index d56e187d..949c9734 100644
--- a/static/alpes-maritimes-2018/_custom.scss
+++ b/static/alpes-maritimes-2018/_custom.scss
@@ -302,7 +302,7 @@ div.homepage-container {
 	}
 }
 
-div.large div#rub_service, div#rub_service {
+div.gru-content div#rub_service, div#rub_service {
 	h2 {
 		text-transform: uppercase;
 		text-align: left;
diff --git a/static/cnil/_custom.scss b/static/cnil/_custom.scss
index a4fe297b..34e4eed8 100644
--- a/static/cnil/_custom.scss
+++ b/static/cnil/_custom.scss
@@ -208,7 +208,7 @@ div.form-validation {
 	}
 }
 
-div.large #rub_service form.quixote {
+div.gru-content #rub_service form.quixote {
 	h3, h4 {
 		clear: both;
 		margin: 25px 0;
diff --git a/static/includes/wcs/_bulk.scss b/static/includes/wcs/_bulk.scss
index 76590983..b55a2c6f 100644
--- a/static/includes/wcs/_bulk.scss
+++ b/static/includes/wcs/_bulk.scss
@@ -82,7 +82,7 @@ div#rub_service h2 {
 	@extend %title;
 }
 
-div.large div#rub_service h3,
+div.gru-content div#rub_service h3,
 div#rub_service h3 {
 	border: none;
 	text-align: left;
diff --git a/static/lille/_custom.scss b/static/lille/_custom.scss
index d96ff83a..2363e09d 100644
--- a/static/lille/_custom.scss
+++ b/static/lille/_custom.scss
@@ -764,7 +764,7 @@ div#rub_service h2 {
 	padding-left: 0;
 }
 
-div.large div#rub_service h3,
+div.gru-content div#rub_service h3,
 div#rub_service h3 {
 	@extend %title;
 	padding-left: 0;
diff --git a/static/metz-metropole-2019/_custom.scss b/static/metz-metropole-2019/_custom.scss
index fb5df9df..57a254a1 100644
--- a/static/metz-metropole-2019/_custom.scss
+++ b/static/metz-metropole-2019/_custom.scss
@@ -907,7 +907,7 @@ div#rub_service div.dataview {
 	font-size: 90%;
 }
 
-div.large div#rub_service h3,
+div.gru-content div#rub_service h3,
 div#rub_service h3 {
 	@extend %title;
 	padding-left: 0;
diff --git a/static/minint/sass/_form.scss b/static/minint/sass/_form.scss
index 46f058bb..6ede092e 100644
--- a/static/minint/sass/_form.scss
+++ b/static/minint/sass/_form.scss
@@ -35,7 +35,7 @@ div#info h2,
 div#accessibility h2,
 div#contact h2,
 div#gauche h3,
-div.large div#rub_service h3,
+div.gru-content div#rub_service h3,
 div#centre h3 {
   padding: 0;
   border: none;
diff --git a/static/minint/sass/_team.scss b/static/minint/sass/_team.scss
index 8762a9ba..d9bbbda4 100644
--- a/static/minint/sass/_team.scss
+++ b/static/minint/sass/_team.scss
@@ -114,7 +114,7 @@ div#gauche { float: none; width: 100%;
   div#accessibility h2,
   div#contact h2,
   div#gauche h3,
-  div.large div#rub_service h3,
+  div.gru-content div#rub_service h3,
   div#centre h3 {
     &.title_form { font-size: em(16, $font-size-base); }
   }
diff --git a/static/villejuif/_custom.scss b/static/villejuif/_custom.scss
index d432bf44..02682e7b 100644
--- a/static/villejuif/_custom.scss
+++ b/static/villejuif/_custom.scss
@@ -121,7 +121,7 @@ form h4{
 	border-bottom: 2px solid $primary-color;
 }
 
-div.large div#rub_service h3,
+div.gru-content div#rub_service h3,
 div#rub_service h3 {
 	background-color: #1ba39c;
 	color: #fff;
diff --git a/templates/theme.html b/templates/theme.html
index b5b9410d..b28bbb4a 100644
--- a/templates/theme.html
+++ b/templates/theme.html
@@ -128,7 +128,7 @@
 {% endblock %}
 
     {% block content-pre %}{% endblock %}
-    <div id="content" class="gru-content large">
+    <div id="content" class="gru-content">
             {% block content-top %}{% endblock %}
             {% block content %}
             {% endblock %}
-- 
2.20.1