From 4e931bf8bd5c26150ebb3b1cbf4d930fd8a30fe4 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Fri, 29 Jan 2021 10:15:35 +0100
Subject: [PATCH] maelis: translate "get" on description endpoints (#47176)

---
 passerelle/locale/fr/LC_MESSAGES/django.po | 28 +++++++++++-----------
 1 file changed, 14 insertions(+), 14 deletions(-)

diff --git a/passerelle/locale/fr/LC_MESSAGES/django.po b/passerelle/locale/fr/LC_MESSAGES/django.po
index 7ca95a90..899acbfc 100644
--- a/passerelle/locale/fr/LC_MESSAGES/django.po
+++ b/passerelle/locale/fr/LC_MESSAGES/django.po
@@ -2,17 +2,17 @@
 # Copyright (C) 2014 Entr'ouvert
 # This file is distributed under the same license as the Passerelle package.
 # Frederic Peters <fpeters@entrouvert.com>, 2014.
 #
 msgid ""
 msgstr ""
 "Project-Id-Version: Passerelle 0\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2021-01-22 00:33+0100\n"
+"POT-Creation-Date: 2021-01-29 03:07-0600\n"
 "PO-Revision-Date: 2021-01-08 09:00+0100\n"
 "Last-Translator: Frederic Peters <fpeters@entrouvert.com>\n"
 "Language: fr\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
@@ -2044,29 +2044,29 @@ msgid "Create link between user and family"
 msgstr "Lier un compte usager à une famille"
 
 #: apps/maelis/models.py:198
 msgid "Delete link between user and family"
 msgstr "Supprimer une liaison entre un compte usager et une famille"
 
 #: apps/maelis/models.py:213 contrib/toulouse_axel/models.py:338
 msgid "Get information about user's family"
-msgstr "Renvoie les informations famille d’un usager"
+msgstr "Obtenir les informations famille d’un usager"
 
 #: apps/maelis/models.py:227 contrib/toulouse_axel/models.py:351
 msgid "Get information about children"
-msgstr "Récupérer la liste des enfants"
+msgstr "Obtenir la liste des enfants"
 
 #: apps/maelis/models.py:241
 msgid "Get information about adults"
-msgstr "Récupérer les informations concernant un enfant"
+msgstr "Obtenir les informations concernant un enfant"
 
 #: apps/maelis/models.py:260 contrib/toulouse_axel/models.py:364
 msgid "Get information about a child"
-msgstr "Récupérer les informations concernant un enfant"
+msgstr "Obtenir les informations concernant un enfant"
 
 #: apps/maelis/models.py:265 apps/maelis/models.py:437
 #: apps/maelis/models.py:465 apps/maelis/models.py:515
 #: apps/maelis/models.py:557 apps/maelis/models.py:606
 #: apps/maelis/models.py:642 contrib/toulouse_axel/models.py:368
 #: contrib/toulouse_axel/models.py:387 contrib/toulouse_axel/models.py:1088
 #: contrib/toulouse_axel/models.py:1161 contrib/toulouse_axel/models.py:1237
 #: contrib/toulouse_axel/models.py:1285
@@ -2078,105 +2078,105 @@ msgid "Update coordinates"
 msgstr "Mettre à jour les coordonnées"
 
 #: apps/maelis/models.py:278 apps/maelis/models.py:381
 msgid "Person ID"
 msgstr "Identifiant de la personne"
 
 #: apps/maelis/models.py:313 contrib/toulouse_axel/models.py:720
 msgid "Get invoices to pay"
-msgstr "Récupérer les factures à payer"
+msgstr "Obtenir les factures à payer"
 
 #: apps/maelis/models.py:316 apps/maelis/models.py:333
 #: apps/maelis/models.py:350 apps/maelis/models.py:368
 #: contrib/toulouse_axel/models.py:723 contrib/toulouse_axel/models.py:739
 #: contrib/toulouse_axel/models.py:755 contrib/toulouse_axel/models.py:777
 #: contrib/toulouse_axel/models.py:823
 msgid "Regie identifier"
 msgstr "Identifiant de la régie"
 
 #: apps/maelis/models.py:330 contrib/toulouse_axel/models.py:736
 msgid "Get invoices already paid"
-msgstr "Récupérer les factures déjà payées"
+msgstr "Obtenir les factures déjà payées"
 
 #: apps/maelis/models.py:347 contrib/stub_invoices/models.py:78
 #: contrib/toulouse_axel/models.py:752
 msgid "Get invoice details"
-msgstr "Récupérer les détails d’une facture"
+msgstr "Obtenir les détails d’une facture"
 
 #: apps/maelis/models.py:351 apps/maelis/models.py:369
 #: contrib/stub_invoices/models.py:82 contrib/stub_invoices/models.py:94
 #: contrib/stub_invoices/models.py:109 contrib/toulouse_axel/models.py:756
 #: contrib/toulouse_axel/models.py:778 contrib/toulouse_axel/models.py:824
 msgid "Invoice identifier"
 msgstr "Identifiant de facture"
 
 #: apps/maelis/models.py:365 contrib/stub_invoices/models.py:89
 #: contrib/toulouse_axel/models.py:774
 msgid "Get invoice as a PDF file"
-msgstr "Récupérer une facture au format PDF"
+msgstr "Obtenir une facture au format PDF"
 
 #: apps/maelis/models.py:377
 msgid "Get activity list"
-msgstr "Récupérer les activités"
+msgstr "Obtenir les activités"
 
 #: apps/maelis/models.py:382
 msgid "School year"
 msgstr "Année scolaire"
 
 #: apps/maelis/models.py:430 apps/maelis/models.py:458
 #: apps/maelis/models.py:508 apps/maelis/models.py:550
 msgid "Activities"
 msgstr "Activités"
 
 #: apps/maelis/models.py:433
 msgid "Get child activities"
-msgstr "Récupérer les activités d’un enfant"
+msgstr "Obtenir les activités d’un enfant"
 
 #: apps/maelis/models.py:439
 msgid "string including E, N or L (default to \"E\")"
 msgstr "chaîne de caractère contenant E, N ou L (« E » par défaut)"
 
 #: apps/maelis/models.py:441
 msgid "subscribed, not-subscribed or None"
 msgstr "subscribed, not-subscribed ou vide"
 
 #: apps/maelis/models.py:442 apps/maelis/models.py:468
 #: apps/maelis/models.py:518
 msgid "Optional querying date (YYYY-MM-DD)"
 msgstr "Date de requête optionnelle (YYYY-MM-DD)"
 
 #: apps/maelis/models.py:461
 msgid "Get bus lines (units)"
-msgstr "Récupérer la liste des lignes de bus (unités)"
+msgstr "Obtenir la liste des lignes de bus (unités)"
 
 #: apps/maelis/models.py:466 apps/maelis/models.py:516
 #: apps/maelis/models.py:607 apps/maelis/models.py:643
 msgid "Activity ID"
 msgstr "Identifiant de l'activité"
 
 #: apps/maelis/models.py:467 apps/maelis/models.py:608
 msgid "Unit ID"
 msgstr "Identifiant de l'unité"
 
 #: apps/maelis/models.py:470
 msgid "aller, retour or None"
 msgstr "aller, retour ou None"
 
 #: apps/maelis/models.py:511
 msgid "Get bus stops (places)"
-msgstr "Récupérer la liste des arrêts de bus (lieux)"
+msgstr "Obtenir la liste des arrêts de bus (lieux)"
 
 #: apps/maelis/models.py:517
 msgid "Bus Unit ID"
 msgstr "Identifiant de l'unité de la ligne de bus"
 
 #: apps/maelis/models.py:553
 msgid "Read child planning"
-msgstr "Récupérer le planning de l’enfant"
+msgstr "Obtenir le planning de l’enfant"
 
 #: apps/maelis/models.py:558
 msgid "Start date (YYYY-MM-DD format)"
 msgstr "Date de début (YYYY-MM-DD)"
 
 #: apps/maelis/models.py:559
 msgid "End date (YYYY-MM-DD format)"
 msgstr "Date de fin (YYYY-MM-DD)"
-- 
2.29.2