From 9bc71ac7e6fce2d06c4813a5ac66ae6ef407fd57 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Fri, 29 Jan 2021 11:37:27 +0100
Subject: [PATCH] villeurbanne-intranet: add theme (#50490)

---
 static/villeurbanne-intranet/_custom.scss | 146 ++++++++++++++++++++++
 static/villeurbanne-intranet/_vars.scss   |  65 ++++++++++
 static/villeurbanne-intranet/config.json  |  17 +++
 static/villeurbanne-intranet/style.scss   |   6 +
 4 files changed, 234 insertions(+)
 create mode 100644 static/villeurbanne-intranet/_custom.scss
 create mode 100644 static/villeurbanne-intranet/_vars.scss
 create mode 100644 static/villeurbanne-intranet/config.json
 create mode 100644 static/villeurbanne-intranet/style.scss

diff --git a/static/villeurbanne-intranet/_custom.scss b/static/villeurbanne-intranet/_custom.scss
new file mode 100644
index 00000000..a1f4f177
--- /dev/null
+++ b/static/villeurbanne-intranet/_custom.scss
@@ -0,0 +1,146 @@
+//
+//	COMPONENTS
+//
+%h1 {
+	border-bottom: 5px solid currentColor;
+	font-size: $fz-h1;
+	color: $primary-color;
+	text-transform: uppercase;
+	font-weight: 700;
+	margin-bottom: 1em;
+}
+
+%h2 {
+	font-size: $fz-h3;
+	color: $primary-color;
+}
+
+%title {
+	border-bottom: 3px solid currentColor;
+}
+
+%cancel-button {
+	color: $red;
+	border-color: currentColor;
+	background-color: white;
+	&:hover {
+		background-color: white;
+		color: $red;
+	}
+}
+
+//
+//	HEADER
+//
+.site-header {
+	height: 160px;
+}
+
+#header-wrapper {
+	background-color: hsla(0, 0%, 100%, 0.8);
+}
+div#header {
+	padding: 0;
+}
+#top {
+	display: flex;
+	flex-wrap: wrap;
+
+	@media ($max-mobile-viewport) {
+	}
+}
+
+#logo,
+#toplinks {
+	flex: 0 0 50%;
+	@media ($max-mobile-viewport) {
+		flex-basis: 100%;
+	}
+}
+
+h1#logo.has-logo {
+	padding: 0;
+	a {
+		display: block;
+		width: 300px;
+		height: 67px;
+		max-width: 100%;
+		@media (max-width: $nav-mobile-limit) {
+			margin: 0 auto;
+		}
+	}
+
+}
+
+#toplinks {
+	position: static;
+	border: none;
+	border-radius: 0;
+	padding: 0 0.7rem;
+	background-color: $gray-xdark;
+	box-shadow: none;
+	max-width: none;
+	min-height: 2.5em;
+	color: white;
+	@media (max-width: $nav-mobile-limit) {
+		order: -1;
+	}
+	> span {
+		height: 100%;
+		display: flex;
+		justify-content: space-around;
+		align-items: center;
+	}
+	.sep {
+		opacity: 0;
+	}
+	a {
+		color: inherit;
+		padding: 0.33em 0.5em;
+	}
+}
+
+//
+//	NAV
+//
+.gru-nav-wrapper {
+	@media (max-width: $nav-mobile-limit) {
+		margin-top: -1 * $nav-menu-side;
+	}
+}
+
+div.gru-nav > ul {
+	margin-top: 0;
+	> li a {
+		font-weight: 500;
+	}
+}
+
+//
+//	CELLS
+//
+.text-cell {
+	overflow: hidden;
+}
+
+
+//
+//	WCS
+//
+div#rub_service {
+	background-color: white;
+	border: .66em solid white;
+
+	h2:first-child {
+		@extend %h1;
+	}
+	h3 {
+		@extend %h2;
+	}
+}
+
+ul#evolutions div.evolution-metadata,
+ul#evolutions li div.msg,
+.tracking-code-part {
+	background-color: white;
+}
\ No newline at end of file
diff --git a/static/villeurbanne-intranet/_vars.scss b/static/villeurbanne-intranet/_vars.scss
new file mode 100644
index 00000000..4ad3db6e
--- /dev/null
+++ b/static/villeurbanne-intranet/_vars.scss
@@ -0,0 +1,65 @@
+// custom vars
+
+$cyan: #0e96a8;
+$cyan-dark: #00545F;
+$cyan-xlight: hsl(185,30%,97%);
+$gray: #E6E7E8;
+$gray-xdark: #231f20;
+$red: #ED1C24;
+
+$ff-ss-serif: Montserrat, sans-serif;
+
+$fz-h1: 1.75em;
+$fz-h2: 1.375em;
+$fz-h3: 1.125em;
+
+// Core vars
+$body-background: $gray;
+$primary-color: $cyan;
+
+$width: 996px;
+
+$font-family: $ff-ss-serif;
+$font-color: $gray-xdark;
+
+$nav-menu-side: 40px;
+$nav-full-width-background: true;
+$nav-background: $cyan-dark;
+$nav-active-color: $cyan;
+$nav-color: white;
+$nav-mobile-menu-background: $cyan-dark;
+$nav-mobile-menu-item-color: white;
+
+$title-background: white;
+$title-color: $cyan;
+$title-font-size: $fz-h3;
+$title-weight: 700;
+$title-transform: uppercase;
+
+$cell-border: none;
+$cell-entry-color: $cyan-dark;
+$cell-entry-hover-color: $red;
+$cell-entry-hover-background: $cyan-xlight;
+$cell-entry-border-color: $gray;
+
+$button-background: $cyan-dark;
+$button-hover-background: $cyan;
+
+$wcs-step-current-color: $primary-color;
+$wcs-step-color: $font-color;
+$wcs-step-current-color: $primary-color;
+$wcs-step-border-bottom: none;
+$wcs-step-marker-background: hsla(0, 0%, 100%, 0.5);
+$wcs-step-current-marker-background: $wcs-step-current-color;
+$wcs-step-current-marker-color: $gray;
+$wcs-step-marker-size: 2em !default;
+$wcs-steps-spacing: 0.7rem;
+
+$widget-unique-checkbox-position: left;
+
+$widget-focus-border: 1px solid $cyan;
+$widget-focus-color: $cyan-dark;
+
+$or-separator: false;
+
+$footer-background: $gray-xdark;
\ No newline at end of file
diff --git a/static/villeurbanne-intranet/config.json b/static/villeurbanne-intranet/config.json
new file mode 100644
index 00000000..8c4402dc
--- /dev/null
+++ b/static/villeurbanne-intranet/config.json
@@ -0,0 +1,17 @@
+{
+  "label": "Villeurbanne Intranet",
+  "variables": {
+    "pwa_display": "standalone",
+    "theme_color": "#0e96a8",
+    "email_header_asset": "emails:logo"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:logo": { "label": "Têtière : logo" },
+        "header:background": { "label": "Têtière : fond" },
+        "emails:logo": {"label": "Emails : logo"}
+      }
+    }
+  }
+}
diff --git a/static/villeurbanne-intranet/style.scss b/static/villeurbanne-intranet/style.scss
new file mode 100644
index 00000000..cf7cc33e
--- /dev/null
+++ b/static/villeurbanne-intranet/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+@import '../includes/fonts/montserrat';
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.20.1